
*******************************************************************************
* Program......: TICKER.PRG
* Author.......: R.H. BUCK
*                OAKLAND, CA
*                (415) 601-1141
* Date.........: 1-20-91
* Module #.....: 13
* dBASE Ver....: IV 1.1 X507A
* Description..: THIS PROGRAM WAS REQUESTED BY A CLIENT WHO WANTED TO LOG 
*                BILLABLE TIME FOR CONSULTING CALLS AND COUNSELLING SESSIONS.
*                BASICALLY, THE USER WOULD SELECT A CLIENT'S RECORD DURING A 
*                SESSION THAT SWITCHED ON THE TIMER.  AT THE END OF THE SESSION
*                THE USER COULD PRESS ANY KEY TO STOP THE TIMER.  THE ELAPSED 
*                TIME WOULD BE SAVED IN THE CLIENT'S RECORD FILE AND THE 
*                BILLABLE TIME CALCULATED.  (OF COURSE I HAD TO CONVERT
*                TIME PERCENTAGES TO CALCALUTE BILLABLE TIME, BUT THAT'S
*                ANOTHER MODULE.)
*******************************************************************************
set talk off
set cursor off
set stat off
clear
timestar=time()                             && INIT. TIME START
x=0                                         && DO WHILE INKEY() INIT.
sec=0
min=0
hr=0
form1="09"                                  && FORMAT FOR TIME DISPLAY 
form2="09"                                  && LESS THAN 10
form3="09"
msec=transform(sec,form3)                   && CONVERT TO CHAR. FORMAT
mmin=transform(min,form2)
mhr=transform(hr,form1)
@11,33 SAY " - Chrono - "                   && CLOCK DISPLAY
@12,33 to 14,44 panel color gb/b            &&
@13,34 fill to 13,43 color n/w              &&
message= "Press Spacebar to Exit"           &&
@23,28 say message                          &&
set color to n/w,w+/n,b                     &&
@13,35 say mhr+":"+mmin+":"+msec            &&
set color to w+/b,b+/w,b                    &&
do whil inkey()=x                           && PROGRAM LOOP
   tickerb=time()
   do whil time()=tickerb                   && TIME DISPLAY LOOP
      msec=transform(sec,form3)
      mmin=transform(min,form2)
      mhr=transform(hr,form1)
      set color to n/w,w+/n,b
      @13,35 say mhr+":"+mmin+":"+msec
   endd
   if time()<>tickerb
      sec=sec+1
      if sec=60                             && ROLLOVER SECONDS/MINUTES
         min=min+1
         sec=0
      endi
      if min=60                             && ROLLOVER MINUTES/HOURS
         hr=hr+1
         min=0
      endi
      if hr=100                             && RESET CLOCK
         sec=0
         min=0
         hr=0
      endi
      if sec>9                              && "DISPLAY" FORMAT CONDITIONS
         form3="99"
      else
         form3="09"
      endi
      if min>9
         form2="99"
      else
         form2="09"
      endi
      if hr>9
         form1="99" 
      else
         form1="09"
      endi
   endi
endd
set color to w+/b,b+/w,b
timestop=time()                             && tracks elapsed time
timesec=val(substr(timestop,7,2))           && init. time variables
timemin=val(substr(timestop,4,2))
timehr=val(substr(timestop,1,2))
if val(substr(timestar,7,2))>;              
   val(substr(timestop,7,2))                && start secs>stopsecs
   timemin=val(substr(timestop,4,2))-1      && sub 1 min from stopmins
   timesec=val(substr(timestop,7,2))+60     && add 60 secs to stopsecs
endi
if val(substr(timestar,4,2))>;
   val(substr(timestop,4,2))                && start mins>stopmins
   timemin=val(substr(timestop,4,2))+60     && add 60 mins to stopmins
   timehr=val(substr(timestop,1,2))-1       && sub 1 hr from stophr
endi
timesec=timesec-val(substr(timestar,7,2))   && sub timestarts from time stops
timemin=timemin-val(substr(timestar,4,2))
timehr=timehr-val(substr(timestar,1,2))
form="99"
msec=transform(timesec,form)                && convert to character strings
mmin=transform(timemin,form)
mhr=transform(timehr,form)
clea
set colo to w/n,n/w
@9,30 say "Time Start: "+timestar
@10,13 to 12,68 panel color gb/b
@11,14 fill to 11,67 color w/n
set colo to w+/n,n/w
@11,15 say "Elapsed Time: ["+mhr+"] Hours: ["+mmin+"] Minutes: "+;
            "["+msec+"] Seconds"
set colo to w/n,n/w
@13,30 say "Time Stop:  "+timestop
set colo to w+/b,b+/w,b
set cursor on
set talk on
retu
